/**************************************************************/
/*                                                            */
/*                                                            */
/*  Written by Jim MacNair - October, 1997                    */
/*                                                            */
/*                                                            */
/**************************************************************/

/**************************************************************/
/* Variable table size definitions                            */
/**************************************************************/

#define MAX_NAME_LEN   32
#define MAX_DATA_LEN   64
#define MAX_VAR_COUNT  100

/**************************************************************/
/* Variable table structure definition                        */
/**************************************************************/

typedef struct {
   char VarName[MAX_NAME_LEN + 1];
   char VarData[MAX_DATA_LEN + 1];
} VARSTRUCT;

/**************************************************************/
/* Maximum characters on a line in the prototype file         */
/**************************************************************/

#define MAX_LINE_LEN   255

/**************************************************************/
/* Maximum number of characters from browser                  */
/**************************************************************/

#define MAX_INPUT_CHAR 4096

/**************************************************************/
/* Function prototype definitions                             */
/**************************************************************/

void short2char(const short s, char *result, const int len);
void int2char(const int i, char *result, const int len);
short reverseBytes(short *var);
int reverseBytes4(int var);
void strupper(char *cStr);
void strcvrt(char *cStr, char cOld, char cNew);
static int TwoHex2Int(char *pC);
void urlDecode(char *p);
void ExpandChar(char *VarData, char ch, char *NewValue);
void get_input_string(char *input_stream);
void parse_input(char *varname, VARSTRUCT *pVars);
void build_header();
void write_html_page(VARSTRUCT *pVars, char *filename);
void build_trailer();

void AddVar(char *varname, char *vardata, VARSTRUCT *pVars);
void UpdateVar(char *varname, char *vardata, VARSTRUCT *pVars);
void GetVarVal(char *varname, char *vardata, VARSTRUCT *pVars);
