// Definitions for Credit Account Inquire/Change/Add Commarea object
//

/////////////////////////////////////////////////////////////////////////////
// Definitions for Standard header and BMS map areas used in COMMAREAs
#include "stdhead.h"
#include "dfhcga.h"
#include "dfhcgb.h"
#include "dfhcgc.h"
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Structure definition file for the CICS Inquire/Update/Add and browse COMMAREAs
#include "credcomm.h"
#include "Brwscomm.h"

/////////////////////////////////////////////////////////////////////////////

// Variable table object definition
#include "vartable.h"

// define a specific user commarea for our application,
class CInqycomm : public CObject
{
public:
	int executeBrowseNext(char brtype, Cvartable& vars, int *usrcalen, void *usrca, CString& mapname);
	int executeStartBrowse(Cvartable& vars, int *usrcalen, void *usrca, CString& mapname);
	CInqycomm(); // standard constructor
	~CInqycomm(); // standard destructor
//	void Dump(CDumpContext& dc) const;

	// Method calls
	int executeInquiry(Cvartable& vars, int *usrcalen, void *usrca);
	int executeChange(Cvartable& vars, int *usrcalen, void *usrca);
	int executeAdd(Cvartable& vars, int *usrcalen, void *usrca);

private:
	// CICS COMMAREA 
	INQYCOMM inqy;		// Inquire, update and add
	BRWSCOMM brws;      // Browse COMMAREA definition

   // Internal subroutines
	int setMenuMapData(Cvartable& vars);
	int setBrwsMenuData(Cvartable& vars);
	int setBrwsMapData(char brtype);
	int setDetailMapData(Cvartable& vars);
	void getDataFromComm(int RC, CString& cics_message, CString& cics_abcode, Cvartable& vars);
	void getBrwsData(Cvartable & vars);
};
