// Login.cpp: implementation of the CLogin class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "credisa.h"
#include "Login.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/* Name of the HTML prototype file */
#define HTML_LOGIN_FILE	"logon.htm"
#define HTML_INQY_FILE	"credinqy.htm"

/* CICS program name */
#define CICSPROG "VERIFYPW"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLogin::CLogin()
{

}

CLogin::~CLogin()
{

}

void CLogin::build_commarea(Cvartable& vars, VERIFYCOMM *pCommArea)

{
	// work variable
	CString vardata;

	// Set the version number 
	memcpy(pCommArea->VERSION,"00",sizeof(pCommArea->VERSION));

	// Fill in the userid and password 
	vardata = vars.GetVarPtr("CICSUSER");
    CCredacctExtension::to_comm(vardata, pCommArea->CICSUSER,
              sizeof(pCommArea->CICSUSER),
              ALPHA_FIELD);

	vardata = vars.GetVarPtr("CICSPW");
    CCredacctExtension::to_comm(vardata, pCommArea->CICSPW,
              sizeof(pCommArea->CICSPW),
              ALPHA_FIELD);

	vardata = vars.GetVarPtr("CICSCLIENT");
    CCredacctExtension::to_comm(vardata, pCommArea->CLIENTNAME,
              sizeof(pCommArea->CLIENTNAME),
              ALPHA_FIELD);
}

int CLogin::performLogon(Cvartable & vars, int* RCode)
{
	// work variables
	CString vardata;
	char RetCode[20];

	// initialize RCode return variable
	*RCode = 0;

	// CICS COMMAREA for password verification program
	VERIFYCOMM pCommArea;

	CString cics_sys = vars.GetVarPtr("CICSSYS");
	CString cics_user = vars.GetVarPtr("CICSUSER");
	CString cics_pw = vars.GetVarPtr("CICSPW");
	CString cics_message;
	CString cics_abcode;

	// initialize the CICS COMMAREA to binary zeros
	memset((void *) &pCommArea, '\0', sizeof(pCommArea));

	// set the COMMAREA fields
	build_commarea(vars, &pCommArea);

	// Get a pointer to the main application object
	CCredacctExtension* myApp = (CCredacctExtension*) AfxGetApp();

	// Execute the CICS Transaction and update the instance variables
	int rc = myApp->executeCICSTran(CICSPROG, sizeof(pCommArea), &pCommArea, 
		                            cics_sys, cics_user, cics_pw, cics_message, cics_abcode);

	if (rc == Ccl::noError)
	{
		memset(RetCode, '\0', sizeof(RetCode));
		memcpy(pCommArea.RESP, RetCode, sizeof(pCommArea.RESP));
		*RCode = atoi(RetCode);
	}
	else
	{
		// set the user message field to indicate a CICS error
		vardata = "Error calling CICS";
		vars.UpdateVar("ERRMSG", vardata);

		// set the ECI error message and abend code
		itoa(rc, RetCode, 10);
		vardata = RetCode;
		vars.UpdateVar("ECIERRCODE", vardata);
		vars.UpdateVar("ECIERRMSG", cics_message);
		vars.UpdateVar("ECIERRABCODE", cics_abcode);

		// Set two formatting variables
		vardata = "<HR>";
		vars.UpdateVar("ECIERRHR", vardata);
		vardata = "<P>";
		vars.UpdateVar("ECIERRNL", vardata);
	}

	return rc;
}
