// CREDISA.CPP - Implementation file for your Internet Server
//    credit account isapi Extension

#include "stdafx.h"
#include "credisa.h"

// CICS COMMAREA objects
#include "Inqycomm.h"

// include for CICS Status file and Variable table routines
#include "statfile.h"

// include for common COMMAREA subroutines
#include "comsubs.h"

// include for ECI subroutines
#include "ecisubs.h"

// request types 
#define REQ_TYPE_CREATE   '0'
#define REQ_TYPE_UPDATE   '1'
#define REQ_TYPE_READ     '2'
#define REQ_TYPE_BROWSE   '3'
#define REQ_TYPE_CLEAR    '4'
#define REQ_TYPE_FORWARD  '5'
#define REQ_TYPE_BACKWARD '6'
#define REQ_TYPE_DISP     '7'

// Names of the HTML template files
#define HTML_LOGIN_FILE	"\\inetpub\\scripts\\isalogon.htm"
#define HTML_INQY_FILE	"\\inetpub\\scripts\\isainqy.htm"
#define HTML_BRWS_FILE	"\\inetpub\\scripts\\isabrws.htm"

///////////////////////////////////////////////////////////////////////
// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;

///////////////////////////////////////////////////////////////////////
// command-parsing map

BEGIN_PARSE_MAP(CCredacctExtension, CHttpServer)
	// TODO: insert your ON_PARSE_COMMAND() and 
	// ON_PARSE_COMMAND_PARAMS() here to hook up your commands.
	// For example:

	ON_PARSE_COMMAND(Default, CCredacctExtension, ITS_EMPTY)
	DEFAULT_PARSE_COMMAND(Default, CCredacctExtension)
	ON_PARSE_COMMAND(Credinqy, CCredacctExtension, ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR
	                                               ITS_PSTR ITS_PSTR ITS_PSTR)
	ON_PARSE_COMMAND_PARAMS("ACCTNO NAME ADDRESS PHONE DATE AMOUNT COMMENT OLDACCOUNT CICSSTATUSFILE REPLAYCOUNT SUBMIT")
	ON_PARSE_COMMAND(Credbrws, CCredacctExtension, ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR ITS_PSTR)
	ON_PARSE_COMMAND_PARAMS("SUBMIT NUMBER1 NUMBER2 NUMBER3 NUMBER4 LASTOP CICSSTATUSFILE REPLAYCOUNT")
END_PARSE_MAP(CCredacctExtension)


///////////////////////////////////////////////////////////////////////
// The one and only CCredacctExtension object

CCredacctExtension theExtension;

///////////////////////////////////////////////////////////////////////
// CCredacctExtension implementation

CCredacctExtension::CCredacctExtension()
{
}

CCredacctExtension::~CCredacctExtension()
{
}

BOOL CCredacctExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CCredacctExtension command handlers
//
// The default routine has been changed to display the CICS
// Logon html page.  This will be displayed if the user types
// the URL for this ISA extension, but no variables are entered.
//
///////////////////////////////////////////////////////////////////////

void CCredacctExtension::Default(CHttpServerContext* pCtxt)
{
	Cvartable	vars;
    char		*filename;
	int			rc;

	// Set the file name to the LOGIN HTML page
    filename = HTML_LOGIN_FILE;

	// write the default LOGON HTML page
	rc = vars.write_html_page(pCtxt, filename);

	if (rc != 0)
	{
		WriteErrorPage(pCtxt, filename);
	}
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CCredacctExtension, CHttpServer)
	//{{AFX_MSG_MAP(CCredacctExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/

//////// Begin insertion ///////////

void CCredacctExtension::WriteErrorPage(CHttpServerContext * pCtxt, char *errMsg)

{
	// failed - we need to send an error page so the
	// user knows what happened

	// write the HTTP headers
	StartContent(pCtxt);
	WriteTitle(pCtxt);

	// Write an Error Message
	*pCtxt << "Error writing page<p>\n";

	*pCtxt << "<h2>" << errMsg << "</h2>";

	// Finish the HTML page
	EndContent(pCtxt);
}

void CCredacctExtension::WriteFileError(CHttpServerContext * pCtxt, char *fileName)

{
	char temp_msg[512];

	// Build an error message
	sprintf(temp_msg, "Error Opening HTML template File - %s", fileName);

	// Display the error page
	WriteErrorPage(pCtxt, temp_msg);
}

void CCredacctExtension::Credinqy(CHttpServerContext* pCtxt, 
								  LPCTSTR acctno,
								  LPCTSTR name,
								  LPCTSTR address,
								  LPCTSTR phone,
								  LPCTSTR date,
								  LPCTSTR amount,
								  LPCTSTR comment,
								  LPCTSTR oldacctno,
								  LPCTSTR statusfile,
								  LPCTSTR replaycount,
								  LPCTSTR submit)

{
	Cvartable vars;
	CInqycomm inqy;
	Cstatfile status;
	CString mapname;
    char   *filename = HTML_INQY_FILE;
	char	usrca[32768];				// User COMMAREA
	char	tctua[256];					// TCT User Area
	char	errmsg[512];
	int usrcalen=sizeof(usrca) - 1;		// Length of saved user COMMAREA
	int	tctualen=0;		// No TCTUA
	int rc=0;
	int	pagecounter=0;
	int	replay=0;
	char reqType = '\0';

	// Clear the mapname variable
	mapname.Empty();

	// Figure out which button was pressed
    if (strcmp(submit, "Add New Account") == 0)
       reqType = REQ_TYPE_CREATE;

    if (strcmp(submit, "Change Account") == 0)
       reqType = REQ_TYPE_UPDATE;

    if (strcmp(submit, "Show Details") == 0)
       reqType = REQ_TYPE_READ;

    if (strcmp(submit, "Browse Accounts") == 0)
       reqType = REQ_TYPE_BROWSE;

    if (strcmp(submit, "Clear Form") == 0)
       reqType = REQ_TYPE_CLEAR;

    if (strcmp(submit, "Return to Inquiry") == 0)
       reqType = REQ_TYPE_DISP;

	// Capture the input form variables
	vars.AddVar(STATFILE, statusfile);

	// Get the CICS status from the status file
	// There is no TCTUA, so pass zeros for length and address
	// This routine will set the REPLAYCOUNT variable 
	rc = status.getStatusfileData(vars, &replay, &tctualen, tctua, &usrcalen, usrca);

	// Check if we were successful
	// We do not want to allow replays for UPDATE requests
	if ((rc == 0) && (reqType == REQ_TYPE_UPDATE))
	{
		// Check for replays of previous web pages
		// First, get the counter from the web page
		pagecounter = atoi(replaycount);

		// Increment the page counter to match the file counter
		pagecounter++;

		// Check the page counter against the status file counter
		if (pagecounter != replay)
		{
			// This page is a replay, don't allow it
			// By setting the return code, this request
			// will be treated as a form clear and will
			// display a blank form with an error message
			strcpy(errmsg,"Replay of previous page not allowed");
			rc = 512;
		}
	}
	else
	{
		// Set error message and treat as a form clear request
		if (rc == 1)
		{
			sprintf(errmsg, "Unable to open status file %s", statusfile);
		}
		else
		{
			sprintf(errmsg, "Status file is invalid %s", statusfile);
		}
	}

	// Handle status file errors and replays
	if (rc != 0)
	{
		// make sure we don't exceed the maximum data length for
		// a variable table entry
		errmsg[MAX_DATA_LEN] = 0;

		// Add the variable to the variable table
		vars.AddVar("ERRMSG", errmsg);

		// Force the request type to be form clear
		reqType = REQ_TYPE_CLEAR;
	}

	if (reqType != REQ_TYPE_CLEAR)
	{
		vars.AddVar("ACCTNO", acctno);
		vars.AddVar("NAME", name);
		vars.AddVar("ADDRESS", address);
		vars.AddVar("PHONE", phone);
		vars.AddVar("DATE", date);
		vars.AddVar("AMOUNT", amount);
		vars.AddVar("COMMENT", comment);
		vars.AddVar("OLDACCTNO", oldacctno);
		vars.AddVar("SUBMIT", submit);

		// Set the CICS COMMAREA length to 0
		usrcalen = 0;
	}

	// Handle inquiries
	if (reqType == REQ_TYPE_READ)
	{
		rc = inqy.executeInquiry(vars, &usrcalen, usrca);
	}

	// Handle changes
	if (reqType == REQ_TYPE_UPDATE)
	{
		rc = inqy.executeChange(vars, &usrcalen, usrca);
	}

	// Handle new adds
	if (reqType == REQ_TYPE_CREATE)
	{
		rc = inqy.executeAdd(vars, &usrcalen, usrca);
	}

	// Handle browse requests
	if (reqType == REQ_TYPE_BROWSE)
	{
		rc = inqy.executeStartBrowse(vars, &usrcalen, usrca, mapname);

		if (mapname.Compare("BROWSE") == 0)
		{
			filename = HTML_BRWS_FILE;
		}

		vars.AddVar("LASTOP", "F");
	}

	// Save the current CICS status in the status file
	// There is no TCTUA, so pass zeros for length and address
	rc = status.updateStatusfile(vars, tctualen, tctua, usrcalen, usrca);

	// Check for errors saving the transaction status
	if (rc != 0)
	{
		// Add an error message to the error message variable
		sprintf(errmsg, "Error saving status file - RC = %d", rc);

		// make sure we don't exceed the maximum data length for
		// a variable table entry
		errmsg[MAX_DATA_LEN] = 0;

		// Add the variable to the variable table
		vars.AddVar("ERRMSG", errmsg);
	}

	// write the html from the template file
	rc = vars.write_html_page(pCtxt, filename);

	if (rc != 0)
	{
		WriteErrorPage(pCtxt, filename);
	}
}

void CCredacctExtension::Credbrws(CHttpServerContext * pCtxt, 
								  LPCTSTR submit, 
								  LPCTSTR number1, 
								  LPCTSTR number2, 
								  LPCTSTR number3, 
								  LPCTSTR number4, 
								  LPCTSTR lastop,
								  LPCTSTR statusfile,
								  LPCTSTR replaycount) 
{
	Cvartable vars;
	CInqycomm inqy;
	Cstatfile status;
	CString mapname;
	char	*filename=HTML_INQY_FILE;
	const char *acctno="";
	char	brtype = '\0';
	char	reqType = '\0';
	char	usrca[32768];				// User COMMAREA
	char	tctua[256];					// TCT User Area
	char	errmsg[512];
	int		replay=0;
	int		pagecounter=0;
	int		usrcalen=sizeof(usrca) - 1;	// Length of saved user COMMAREA
	int		tctualen=0;					// No TCTUA
	int		rc=0;

	// determine the type of request, based on the HTML button
    if (strcmp(submit, "Page Forward") == 0)
	{
       reqType = REQ_TYPE_FORWARD;
	   brtype = 'F';
	   vars.AddVar("LASTOP", "F");
	}

    if (strcmp(submit, "Page Backward") == 0)
	{
       reqType = REQ_TYPE_BACKWARD;
	   brtype = 'B';
	   vars.AddVar("LASTOP", "B");
	}

    if (strcmp(submit, "Display Account 1") == 0)
	{
       reqType = REQ_TYPE_DISP;
	   acctno = number1;
	}

    if (strcmp(submit, "Display Account 2") == 0)
	{
       reqType = REQ_TYPE_DISP;
	   acctno = number2;
	}

    if (strcmp(submit, "Display Account 3") == 0)
	{
       reqType = REQ_TYPE_DISP;
	   acctno = number3;
	}

    if (strcmp(submit, "Display Account 4") == 0)
	{
       reqType = REQ_TYPE_DISP;
	   acctno = number4;
	}

    if (strcmp(submit, "Return to Inquiry") == 0)
	{
		// Set request type
		reqType = REQ_TYPE_DISP;

		// display the first account displayed
		// start with the first one
		acctno = number1;
		if (acctno[0] == 0)
		{
			acctno = number2;
			if (acctno[0] == 0)
			{
				acctno = number3;
				if (acctno[0] == 0)
				{
					acctno = number4;
				}
			}
		}
	}

	// Capture the input form variables
	vars.AddVar(STATFILE, statusfile);

	// Get the CICS status from the status file
	// There is no TCTUA, so pass zeros for length and address
	// This routine will set the REPLAYCOUNT variable 
	rc = status.getStatusfileData(vars, &replay, &tctualen, tctua, &usrcalen, usrca);

	// Set error message and treat as a form clear request
	if (rc == 1)
	{
		sprintf(errmsg, "Unable to open status file %s", statusfile);
	}
	else
	{
		sprintf(errmsg, "Status file is invalid %s", statusfile);
	}

	// Check if we were successful
	// We do not want to allow replays for UPDATE requests
	if ((rc == 0) && 
		((reqType == REQ_TYPE_FORWARD) || (reqType == REQ_TYPE_BACKWARD)))
	{
		// Check for replays of previous web pages
		// First, get the counter from the web page
		pagecounter = atoi(replaycount);

		// Increment the page counter to match the file counter
		pagecounter++;

		// Check the page counter against the status file counter
		if (pagecounter != replay)
		{
			// This page is a replay, don't allow it
			// By setting the return code, this request
			// will be treated as a form clear and will
			// display a blank form with an error message
			strcpy(errmsg,"Replay of previous page not allowed");

			// set return code to indicate replay error
			rc = 100;
		}
	}

	// Handle status file errors and replays
	if (rc != 0)
	{
		// make sure we don't exceed the maximum data length for
		// a variable table entry
		errmsg[MAX_DATA_LEN] = 0;

		// Add the variable to the variable table
		vars.AddVar("ERRMSG", errmsg);

		// Force the request type to be form clear
		acctno = "";
		reqType = REQ_TYPE_DISP;

		// Don't save the user COMMAREA
		usrcalen = 0;
	}

	// Handle browse forward or backward requests
	if ((reqType == REQ_TYPE_FORWARD) || (reqType == REQ_TYPE_BACKWARD))
	{
		rc = inqy.executeBrowseNext(brtype, vars, &usrcalen, usrca, mapname);
		if (mapname.Compare("BROWSE") == 0)
		{
			filename = HTML_BRWS_FILE;
		}
	}

	// Handle display requests for one of the current accounts
	if (reqType == REQ_TYPE_DISP)
	{
		if (acctno[0] != '\0')
		{
			// Add the account number variable to the variable table
			vars.AddVar("ACCTNO", acctno);
			// Get the data for the selected account
			rc = inqy.executeInquiry(vars, &usrcalen, usrca);
		}
	}

	// Save the current CICS status in the status file
	rc = status.updateStatusfile(vars, tctualen, tctua, usrcalen, usrca);

	// Check for errors saving the transaction status
	if (rc != 0)
	{
		// Add an error message to the error message variable
		sprintf(errmsg, "Error saving status file - RC = %d", rc);

		// make sure we don't exceed the maximum data length for
		// a variable table entry
		errmsg[MAX_DATA_LEN] = 0;

		// Add the variable to the variable table
		vars.AddVar("ERRMSG", errmsg);
	}

	// write the output HTML page
	rc = vars.write_html_page(pCtxt, filename);

	// check if it worked
	if (rc != 0)
	{
		// Error writing the HTML page - display an error page
		WriteFileError(pCtxt, filename);
	}
}
